// Package docs GENERATED BY SWAG; DO NOT EDIT
// This file was generated by swaggo/swag
package docs

import "github.com/swaggo/swag"

const docTemplate = `{
    "schemes": {{ marshal .Schemes }},
    "swagger": "2.0",
    "info": {
        "description": "{{escape .Description}}",
        "title": "{{.Title}}",
        "contact": {},
        "license": {
            "name": "Apache 2.0",
            "url": "http://www.apache.org/licenses/LICENSE-2.0.html"
        },
        "version": "{{.Version}}"
    },
    "host": "{{.Host}}",
    "basePath": "{{.BasePath}}",
    "paths": {
        "/auth/force_logout": {
            "post": {
                "description": "对应的平台强制登出",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "鉴权认证"
                ],
                "summary": "强制登出",
                "operationId": "ForceLogout",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "platform为平台ID \u003cbr\u003e fromUserID为要执行强制登出的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.ForceLogoutReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.ForceLogoutResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/auth/parse_token": {
            "post": {
                "description": "解析当前用户token(token在请求头中传入)",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "鉴权认证"
                ],
                "summary": "解析当前用户token",
                "operationId": "ParseToken",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "secret为openIM密钥, 详细见服务端config.yaml secret字段\u003cbr\u003eplatform为平台ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.ParseTokenReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.ParseTokenResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "Data": {
                                            "$ref": "#/definitions/base_info.ExpireTime"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/auth/user_register": {
            "post": {
                "description": "用户注册",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "鉴权认证"
                ],
                "summary": "用户注册",
                "operationId": "UserRegister",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "secret为openIM密钥, 详细见服务端config.yaml secret字段 \u003cbr\u003e platform为平台ID \u003cbr\u003e ex为拓展字段 \u003cbr\u003e gender为性别, 0为女, 1为男",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.UserRegisterReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.UserRegisterResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/auth/user_token": {
            "post": {
                "description": "获取用户的token",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "鉴权认证"
                ],
                "summary": "用户登录",
                "operationId": "UserToken",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "secret为openIM密钥, 详细见服务端config.yaml secret字段 \u003cbr\u003e platform为平台ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.UserTokenReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.UserTokenResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/add_black": {
            "post": {
                "description": "添加黑名单",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "添加黑名单",
                "operationId": "AddBlack",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为设置的用户 \u003cbr\u003e toUserID为被设置的用户",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.AddBlacklistReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.AddBlacklistResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/add_friend": {
            "post": {
                "description": "添加好友",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "添加好友",
                "operationId": "AddFriend",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "reqMsg为申请信息 \u003cbr\u003e fromUserID为申请用户 \u003cbr\u003e toUserID为被添加用户",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.AddFriendReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.AddFriendResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/add_friend_response": {
            "post": {
                "description": "同意/拒绝好友请求",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "同意/拒绝好友请求",
                "operationId": "AddFriendResponse",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID同意/拒绝的用户ID\u003cbr\u003etoUserID为申请用户D\u003cbr\u003ehandleMsg为处理信息\u003cbr\u003eflag为具体操作, 1为同意, 2为拒绝",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.AddFriendResponseReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.AddFriendResponseResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/delete_friend": {
            "post": {
                "description": "删除好友",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "删除好友",
                "operationId": "DeleteFriend",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为操作用户\u003cbr\u003etoUserID为被删除用户",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteFriendReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteFriendResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/get_black_list": {
            "post": {
                "description": "获取黑名单列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "获取黑名单列表",
                "operationId": "GetBlacklist",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID要获取黑名单的用户",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetBlackListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetBlackListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.PublicUserInfo"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    }
                }
            }
        },
        "/friend/get_friend_apply_list": {
            "post": {
                "description": "删除好友",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "获取好友申请列表",
                "operationId": "GetFriendApplyList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为要获取申请列表的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetFriendApplyListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetFriendApplyListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.FriendRequest"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    }
                }
            }
        },
        "/friend/get_friend_list": {
            "post": {
                "description": "获取用户的好友列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "获取用户的好友列表",
                "operationId": "GetFriendList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为要获取好友列表的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetFriendListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetFriendListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.FriendInfo"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/get_self_friend_apply_list": {
            "post": {
                "description": "获取自己的好友申请列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "获取自己的好友申请列表",
                "operationId": "GetSelfFriendApplyList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为自己的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetSelfApplyListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetSelfApplyListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.FriendRequest"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/import_friend": {
            "post": {
                "description": "批量加好友",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "批量加好友",
                "operationId": "ImportFriend",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID批量加好友的用户ID\u003cbr\u003e friendUserIDList为",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.ImportFriendReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "data列表中对象的result-1为添加该用户失败\u003cbr\u003e0为成功",
                        "schema": {
                            "$ref": "#/definitions/base_info.ImportFriendResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/is_friend": {
            "post": {
                "description": "检查用户之间是否为好友",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "检查用户之间是否为好友",
                "operationId": "IsFriend",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为请求用户\u003cbr\u003e toUserID为要检查的用户",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.IsFriendReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.IsFriendResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/remove_black": {
            "post": {
                "description": "把用户移除黑名单",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "把用户移除黑名单",
                "operationId": "RemoveBlack",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID要获取黑名单的用户",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.RemoveBlackListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.RemoveBlackListResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/friend/set_friend_remark": {
            "post": {
                "description": "设置好友备注",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "好友相关"
                ],
                "summary": "设置好友备注",
                "operationId": "SetFriendRemark",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为设置的用户\u003cbr\u003e toUserID为被设置的用户\u003cbr\u003e remark为好友备注",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.SetFriendRemarkReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.SetFriendRemarkResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/cancel_mute_group": {
            "post": {
                "description": "取消禁言群组",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "取消禁言群组",
                "operationId": "CancelMuteGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为群组ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CancelMuteGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CancelMuteGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/cancel_mute_group_member": {
            "post": {
                "description": "取消禁言群成员",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "取消禁言群成员",
                "operationId": "CancelMuteGroupMember",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为群组ID \u003cbr\u003e userID为要取消禁言的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CancelMuteGroupMemberReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CancelMuteGroupMemberResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/create_group": {
            "post": {
                "description": "创建群组",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "创建群组",
                "operationId": "CreateGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupType这里填0代表普通群 \u003cbr\u003egroupName为群名称\u003cbr\u003e introduction为群介绍\u003cbr\u003e notification为群公共\u003cbr\u003eownerUserID为群主ID \u003cbr\u003e ex为群扩展字段 \u003cbr\u003e memberList中对象roleLevel为群员角色,1为普通用户 2为群主 3为管理员",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.CreateGroupResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/server_api_params.GroupInfo"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/dismiss_group": {
            "post": {
                "description": "解散群组",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "解散群组",
                "operationId": "DismissGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为要解散的群组ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DismissGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DismissGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/get_group_all_member_list": {
            "post": {
                "description": "获取全部群成员列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "获取全部群成员列表",
                "operationId": "GetGroupAllMemberList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "GroupID为要获取群成员的群ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetGroupAllMemberReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetGroupAllMemberResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.GroupMemberFullInfo"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/get_group_members_info": {
            "post": {
                "description": "获取群成员信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "获取群成员信息",
                "operationId": "GetGroupMembersInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为要获取的群ID \u003cbr\u003e memberList为要获取群成员的群ID列表",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetGroupMembersInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetGroupMembersInfoResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.GroupMemberFullInfo"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/get_groups_info": {
            "post": {
                "description": "通过群ID列表获取群信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "通过群ID列表获取群信息",
                "operationId": "GetGroupsInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupIDList为群ID列表",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetGroupInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetGroupInfoResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/get_joined_group_list": {
            "post": {
                "description": "获取用户加入群列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "获取用户加入群列表",
                "operationId": "GetJoinedGroupList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为要获取的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetJoinedGroupListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetJoinedGroupListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.GroupInfo"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/get_recv_group_applicationList": {
            "post": {
                "description": "获取用户收到的加群信息列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "获取用户收到的加群信息列表",
                "operationId": "GetRecvGroupApplicationList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "fromUserID为要获取的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetGroupApplicationListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetGroupApplicationListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.GroupRequest"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/get_user_req_group_applicationList": {
            "post": {
                "description": "获取用户加群申请列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "获取用户加群申请列表",
                "operationId": "GetUserReqGroupApplicationList",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "userID为要获取的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserReqGroupApplicationListReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetGroupApplicationListResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.GroupRequest"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/group_application_response": {
            "post": {
                "description": "处理加群消息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "处理加群消息",
                "operationId": "ApplicationGroupResponse",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为要处理的群ID \u003cbr\u003e fromUserID为要处理的用户ID \u003cbr\u003e handleMsg为处理结果信息 \u003cbr\u003e handleResult为处理结果 1为同意加群 2为拒绝加群",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.ApplicationGroupResponseReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.ApplicationGroupResponseResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/invite_user_to_group": {
            "post": {
                "description": "将用户拉入群组",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "将用户拉入群组",
                "operationId": "InviteUserToGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为要拉进的群组ID \u003cbr\u003e invitedUserIDList为要获取群成员的群ID列表 \u003cbr\u003e reason为原因",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.InviteUserToGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "result为结果码, -1为失败, 0为成功",
                        "schema": {
                            "$ref": "#/definitions/base_info.InviteUserToGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/join_group": {
            "post": {
                "description": "加入群聊",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "加入群聊",
                "operationId": "JoinGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "reqMessage为申请进群信息\u003cbr\u003egroupID为申请的群ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.JoinGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.JoinGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/kick_group": {
            "post": {
                "description": "把用户踢出群组",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "把用户踢出群组",
                "operationId": "KickGroupMember",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "GroupID为要操作的群ID \u003cbr\u003e kickedUserIDList为要踢出的群用户ID \u003cbr\u003e reason为原因",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.KickGroupMemberReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "result为结果码, -1为失败, 0为成功",
                        "schema": {
                            "$ref": "#/definitions/base_info.KickGroupMemberResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/mute_group": {
            "post": {
                "description": "禁言群组",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "禁言群组",
                "operationId": "MuteGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为群组ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.MuteGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.MuteGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.MuteGroupResp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.MuteGroupResp"
                        }
                    }
                }
            }
        },
        "/group/mute_group_member": {
            "post": {
                "description": "禁言群成员",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "禁言群成员",
                "operationId": "MuteGroupMember",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为群组ID \u003cbr\u003e userID为要禁言的用户ID \u003cbr\u003e mutedSeconds为禁言秒数",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.MuteGroupMemberReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DismissGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/quit_group": {
            "post": {
                "description": "当前用户退出群聊",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "当前用户退出群聊",
                "operationId": "QuitGroup",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为要退出的群ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.QuitGroupReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.QuitGroupResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/set_group_info": {
            "post": {
                "description": "设置群信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "设置群信息",
                "operationId": "SetGroupInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "groupID为要修改的群ID\u003cbr\u003egroupName为新的群名称\u003cbr\u003enotification为群介绍 \u003cbr\u003e introduction为群公告 \u003cbr\u003e needVerification为加群验证 0为申请需要同意 邀请直接进 1为所有人进群需要验证，除了群主管理员邀请进群 2为直接进群",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.SetGroupInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.SetGroupInfoResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/set_group_member_info": {
            "post": {
                "description": "修改群成员信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "修改群成员信息",
                "operationId": "SetGroupMemberInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "除了operationID, userID, groupID其他参数可选\u003cbr\u003eex为拓展字段\u003cbr\u003efaceURL为群头像\u003cbr\u003enickName为群昵称\u003cbr\u003eroleLevel为群员角色,1为普通用户 2为群主 3为管理员",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.SetGroupMemberInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.SetGroupMemberInfoResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/group/transfer_group": {
            "post": {
                "description": "转让群主",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "群组相关"
                ],
                "summary": "转让群主",
                "operationId": "TransferGroupOwner",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "GroupID为要操作的群ID \u003cbr\u003e oldOwnerUserID为老群主ID \u003cbr\u003e newOwnerUserID为新群主ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.TransferGroupOwnerReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.TransferGroupOwnerResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/msg/batch_send_msg": {
            "post": {
                "description": "管理员批量发送群聊单聊消息 消息格式详细见\u003ca href=\"https://doc.rentsoft.cn/#/server_doc/admin?id=%e6%b6%88%e6%81%af%e7%b1%bb%e5%9e%8b%e6%a0%bc%e5%bc%8f%e6%8f%8f%e8%bf%b0\"\u003e消息格式\u003c/href\u003e",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "消息相关"
                ],
                "summary": "管理员批量发送群聊单聊消息",
                "operationId": "ManagementBatchSendMsg",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "该请求和消息结构体一样 \u003cbr\u003e recvIDList为接受消息的用户ID列表",
                        "name": "管理员批量发送单聊消息",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.ManagementBatchSendMsgReq"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "content": {
                                            "$ref": "#/definitions/Open_IM_internal_api_manage.TextElem"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    {
                        "description": "该请求和消息结构体一样 \u003cbr\u003e recvIDList为接受消息的用户ID列表",
                        "name": "管理员批量发送OA通知",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.ManagementSendMsgReq"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "content": {
                                            "$ref": "#/definitions/Open_IM_internal_api_manage.OANotificationElem"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "serverMsgID为服务器消息ID \u003cbr\u003e clientMsgID为客户端消息ID \u003cbr\u003e sendTime为发送消息时间",
                        "schema": {
                            "$ref": "#/definitions/base_info.ManagementBatchSendMsgReq"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.ManagementBatchSendMsgReq"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.ManagementBatchSendMsgReq"
                        }
                    }
                }
            }
        },
        "/msg/clear_msg": {
            "post": {
                "description": "清空用户消息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "消息相关"
                ],
                "summary": "清空用户消息",
                "operationId": "ClearMsg",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "userID为要清空的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CleanUpMsgReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CleanUpMsgResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/msg/del_msg": {
            "post": {
                "description": "根据seq列表删除消息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "消息相关"
                ],
                "summary": "根据seq列表删除消息",
                "operationId": "DelMsg",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "userID为要删除的用户ID \u003cbr\u003e seqList为seq列表",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DelMsgReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DelMsgResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/msg/get_all_conversations": {
            "post": {
                "description": "获取用户所有会话",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "会话相关"
                ],
                "summary": "获取用户所有会话",
                "operationId": "GetAllConversations",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "ownerUserID为要获取的用户ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetAllConversationsReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetAllConversationsResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/msg/get_conversation": {
            "post": {
                "description": "根据会话ID获取会话",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "会话相关"
                ],
                "summary": "根据会话ID获取会话",
                "operationId": "GetConversation",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "ownerUserID为要获取的用户ID\u003cbr\u003econversationID为要获取的会话ID",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetConversationReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetConversationResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/msg/get_conversations": {
            "post": {
                "description": "根据会话ID列表获取会话",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "会话相关"
                ],
                "summary": "根据会话ID列表获取会话",
                "operationId": "GetConversations",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "ownerUserID为要获取的用户ID\u003cbr\u003econversationIDs为要获取的会话ID列表",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetConversationsReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetConversationsResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/msg/manage_send_msg": {
            "post": {
                "description": "管理员发送/撤回消息 消息格式详细见\u003ca href=\"https://doc.rentsoft.cn/#/server_doc/admin?id=%e6%b6%88%e6%81%af%e7%b1%bb%e5%9e%8b%e6%a0%bc%e5%bc%8f%e6%8f%8f%e8%bf%b0\"\u003e消息格式\u003c/href\u003e",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "消息相关"
                ],
                "summary": "管理员发送/撤回消息",
                "operationId": "ManagementSendMsg",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "该请求和消息结构体一样",
                        "name": "管理员发送文字消息",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.ManagementSendMsgReq"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "content": {
                                            "$ref": "#/definitions/Open_IM_internal_api_manage.TextElem"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    {
                        "description": "该请求和消息结构体一样",
                        "name": "管理员发送OA通知消息",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.ManagementSendMsgReq"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "content": {
                                            "$ref": "#/definitions/Open_IM_internal_api_manage.OANotificationElem"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    {
                        "description": "该请求和消息结构体一样",
                        "name": "管理员撤回单聊消息",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.ManagementSendMsgReq"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "content": {
                                            "$ref": "#/definitions/Open_IM_internal_api_manage.RevokeElem"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "serverMsgID为服务器消息ID \u003cbr\u003e clientMsgID为客户端消息ID \u003cbr\u003e sendTime为发送消息时间",
                        "schema": {
                            "$ref": "#/definitions/base_info.ManagementSendMsgResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.ManagementSendMsgResp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.ManagementSendMsgResp"
                        }
                    }
                }
            }
        },
        "/office/comment_one_work_moment": {
            "post": {
                "description": "评论一条工作圈",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "评论一条工作圈",
                "operationId": "CommentOneWorkMoment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CommentOneWorkMomentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CommentOneWorkMomentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/create_one_work_moment": {
            "post": {
                "description": "用户创建一条工作圈",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "创建一条工作圈",
                "operationId": "CreateOneWorkMoment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求 atUserList likeUserList permissionGroupList permissionUserList 字段中userName可以不填",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateOneWorkMomentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateOneWorkMomentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/create_tag": {
            "post": {
                "description": "创建标签",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "创建标签",
                "operationId": "CreateTag",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateTagReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateTagResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/delete_comment": {
            "post": {
                "description": "删除一条评论",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "删除一条评论",
                "operationId": "DeleteComment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteCommentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteCommentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/delete_one_work_moment": {
            "post": {
                "description": "根据用户工作圈ID删除一条工作圈",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "删除一条工作圈",
                "operationId": "DeleteOneWorkMoment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteOneWorkMomentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteOneWorkMomentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/delete_tag": {
            "post": {
                "description": "根据标签ID创建标签",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "删除标签",
                "operationId": "DeleteTag",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteTagReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteTagResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/get_send_tag_log": {
            "post": {
                "description": "分页获取发送历史记录",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "获取发送历史记录",
                "operationId": "GetTagSendLogs",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetTagSendLogsReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetTagSendLogsResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/get_user_friend_work_moments": {
            "post": {
                "description": "查询用户工作圈页面",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "查询自己大工作圈页面",
                "operationId": "GetUserFriendWorkMoments",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserFriendWorkMomentsReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserFriendWorkMomentsResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/get_user_tag_by_id": {
            "post": {
                "description": "通过标签id获取该用户的标签信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "获取该用户的标签信息",
                "operationId": "GetUserTagByID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserTagByIDReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserTagByIDResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/get_user_tags": {
            "post": {
                "description": "用户获取自己的所有的标签",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "获取用户标签信息",
                "operationId": "GetUserTags",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserTagsReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserTagsResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/get_user_work_moments": {
            "post": {
                "description": "查询用户工作圈",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "查询用户工作圈",
                "operationId": "GetUserWorkMoments",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserWorkMomentsReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserWorkMomentsResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/get_work_moment_by_id": {
            "post": {
                "description": "通过ID获取工作圈",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "通过ID获取工作圈",
                "operationId": "GetWorkMomentByID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetWorkMomentByIDReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetWorkMomentByIDResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/like_one_work_moment": {
            "post": {
                "description": "工作圈ID点赞一条工作圈",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "工作圈"
                ],
                "summary": "点赞一条工作圈",
                "operationId": "LikeOneWorkMoment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.LikeOneWorkMomentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.LikeOneWorkMomentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/send_msg_to_tag": {
            "post": {
                "description": "对标签用户发送消息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "发送标签消息",
                "operationId": "SendMsg2Tag",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.SendMsg2TagReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.SendMsg2TagResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/office/set_tag": {
            "post": {
                "description": "根据标签ID修改标签用户列表, 名称",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "标签"
                ],
                "summary": "修改标签",
                "operationId": "SetTag",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.SetTagReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.SetTagResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/create_department": {
            "post": {
                "description": "创建部门",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "创建部门",
                "operationId": "CreateDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.CreateDepartmentResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/server_api_params.Department"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/create_department_member": {
            "post": {
                "description": "创建部门用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "创建部门用户",
                "operationId": "CreateDepartmentMember",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateDepartmentMemberReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateDepartmentMemberResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/create_organization_user": {
            "post": {
                "description": "组织架构导入用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "组织架构导入用户",
                "operationId": "CreateOrganizationUser",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateOrganizationUserReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.CreateOrganizationUserResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/delete_department": {
            "post": {
                "description": "删除部门",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "删除部门",
                "operationId": "DeleteDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteDepartmentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/delete_organization_user": {
            "post": {
                "description": "删除组织架构中某个用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "删除组织架构中某个用户",
                "operationId": "DeleteOrganizationUser",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteOrganizationUserReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteOrganizationUserResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/delete_user_in_department": {
            "post": {
                "description": "删除部门中某个用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "删除部门中某个用户",
                "operationId": "DeleteUserInDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteUserInDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.DeleteUserInDepartmentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/get_department_member": {
            "post": {
                "description": "获取部门中所有成员",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "获取部门中所有成员",
                "operationId": "GetDepartmentMember",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetDepartmentMemberReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetDepartmentMemberResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.UserDepartmentMember"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/get_sub_department": {
            "post": {
                "description": "获取子部门列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "获取子部门列表",
                "operationId": "GetSubDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetSubDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetSubDepartmentResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.Department"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/get_user_in_department": {
            "post": {
                "description": "获取部门中的所有用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "获取部门中的所有用户",
                "operationId": "GetUserInDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUserInDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetUserInDepartmentResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/server_api_params.UserInDepartment"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/update_department": {
            "post": {
                "description": "更新部门信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "更新部门信息",
                "operationId": "UpdateDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateDepartmentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/update_organization_user": {
            "post": {
                "description": "更新组织架构中的用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "更新组织架构中的用户",
                "operationId": "UpdateOrganizationUser",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateOrganizationUserReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateOrganizationUserResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/organization/update_user_in_department": {
            "post": {
                "description": "更新部门中某个用户",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "组织架构相关"
                ],
                "summary": "更新部门中某个用户",
                "operationId": "UpdateUserInDepartment",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateUserInDepartmentReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateUserInDepartmentResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/third/minio_upload": {
            "post": {
                "description": "minio上传文件(web api), 请注意本api请求为form并非json",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "第三方服务相关"
                ],
                "summary": "minio上传文件(web api)",
                "operationId": "MinioUploadFile",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "type": "file",
                        "description": "要上传的文件文件",
                        "name": "file",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "文件类型",
                        "name": "fileType",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "操作唯一ID",
                        "name": "operationID",
                        "in": "formData",
                        "required": true
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.MinioUploadFileResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/account_check": {
            "post": {
                "description": "传入UserIDList检查列表账户注册状态，并且返回结果",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "检查列表账户注册状态，并且返回结果",
                "operationId": "AccountCheck",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求体",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.AccountCheckReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.AccountCheckResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/get_all_users_uid": {
            "post": {
                "description": "获取所有用户uid列表",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "获取所有用户uid列表",
                "operationId": "GetAllUsersUid",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求体",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetAllUsersUidReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetAllUsersUidResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/get_self_user_info": {
            "post": {
                "description": "传入ID获取自己的信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "获取自己的信息",
                "operationId": "GetSelfUserInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求体",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetSelfUserInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetSelfUserInfoResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/server_api_params.UserInfo"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/get_users_info": {
            "post": {
                "description": "根据用户列表批量获取用户信息",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "获取用户信息",
                "operationId": "GetUsersInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求体",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUsersInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/base_info.GetUsersInfoResp"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "Data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/server_api_params.PublicUserInfo"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/get_users_online_status": {
            "post": {
                "description": "获取用户在线状态",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "获取用户在线状态",
                "operationId": "GetUsersOnlineStatus",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求体",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUsersOnlineStatusReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.GetUsersOnlineStatusResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/set_global_msg_recv_opt": {
            "post": {
                "description": "设置全局免打扰",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "设置全局免打扰",
                "operationId": "SetGlobalRecvMessageOpt",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "globalRecvMsgOpt为全局免打扰设置0为关闭 1为开启",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.SetGlobalRecvMessageOptReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.SetGlobalRecvMessageOptResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        },
        "/user/update_user_info": {
            "post": {
                "description": "修改用户信息 userID faceURL等",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "用户相关"
                ],
                "summary": "修改用户信息",
                "operationId": "UpdateUserInfo",
                "parameters": [
                    {
                        "type": "string",
                        "description": "im token",
                        "name": "token",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "请求体",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateSelfUserInfoReq"
                        }
                    }
                ],
                "responses": {
                    "0": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/base_info.UpdateUserInfoResp"
                        }
                    },
                    "400": {
                        "description": "errCode为400 一般为参数输入错误, token未带上等",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger400Resp"
                        }
                    },
                    "500": {
                        "description": "errCode为500 一般为服务器内部错误",
                        "schema": {
                            "$ref": "#/definitions/base_info.Swagger500Resp"
                        }
                    }
                }
            }
        }
    },
    "definitions": {
        "Open_IM_internal_api_manage.FileElem": {
            "type": "object",
            "properties": {
                "fileName": {
                    "type": "string"
                },
                "filePath": {
                    "type": "string"
                },
                "fileSize": {
                    "type": "integer"
                },
                "sourceURL": {
                    "type": "string"
                },
                "uuid": {
                    "type": "string"
                }
            }
        },
        "Open_IM_internal_api_manage.OANotificationElem": {
            "type": "object",
            "required": [
                "notificationFaceURL",
                "notificationName",
                "notificationType",
                "text"
            ],
            "properties": {
                "ex": {
                    "type": "string"
                },
                "fileElem": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.FileElem"
                },
                "mixType": {
                    "type": "integer"
                },
                "notificationFaceURL": {
                    "type": "string"
                },
                "notificationName": {
                    "type": "string"
                },
                "notificationType": {
                    "type": "integer"
                },
                "pictureElem": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.PictureElem"
                },
                "soundElem": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.SoundElem"
                },
                "text": {
                    "type": "string"
                },
                "url": {
                    "type": "string"
                },
                "videoElem": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.VideoElem"
                }
            }
        },
        "Open_IM_internal_api_manage.PictureBaseInfo": {
            "type": "object",
            "properties": {
                "height": {
                    "type": "integer"
                },
                "size": {
                    "type": "integer"
                },
                "type": {
                    "type": "string"
                },
                "url": {
                    "type": "string"
                },
                "uuid": {
                    "type": "string"
                },
                "width": {
                    "type": "integer"
                }
            }
        },
        "Open_IM_internal_api_manage.PictureElem": {
            "type": "object",
            "properties": {
                "bigPicture": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.PictureBaseInfo"
                },
                "snapshotPicture": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.PictureBaseInfo"
                },
                "sourcePath": {
                    "type": "string"
                },
                "sourcePicture": {
                    "$ref": "#/definitions/Open_IM_internal_api_manage.PictureBaseInfo"
                }
            }
        },
        "Open_IM_internal_api_manage.RevokeElem": {
            "type": "object",
            "required": [
                "revokeMsgClientID"
            ],
            "properties": {
                "revokeMsgClientID": {
                    "type": "string"
                }
            }
        },
        "Open_IM_internal_api_manage.SoundElem": {
            "type": "object",
            "properties": {
                "dataSize": {
                    "type": "integer"
                },
                "duration": {
                    "type": "integer"
                },
                "soundPath": {
                    "type": "string"
                },
                "sourceURL": {
                    "type": "string"
                },
                "uuid": {
                    "type": "string"
                }
            }
        },
        "Open_IM_internal_api_manage.TextElem": {
            "type": "object",
            "required": [
                "text"
            ],
            "properties": {
                "text": {
                    "type": "string"
                }
            }
        },
        "Open_IM_internal_api_manage.VideoElem": {
            "type": "object",
            "properties": {
                "duration": {
                    "type": "integer"
                },
                "snapshotHeight": {
                    "type": "integer"
                },
                "snapshotPath": {
                    "type": "string"
                },
                "snapshotSize": {
                    "type": "integer"
                },
                "snapshotURL": {
                    "type": "string"
                },
                "snapshotUUID": {
                    "type": "string"
                },
                "snapshotWidth": {
                    "type": "integer"
                },
                "videoPath": {
                    "type": "string"
                },
                "videoSize": {
                    "type": "integer"
                },
                "videoType": {
                    "type": "string"
                },
                "videoURL": {
                    "type": "string"
                },
                "videoUUID": {
                    "type": "string"
                }
            }
        },
        "base_info.AccountCheckReq": {
            "type": "object",
            "required": [
                "checkUserIDList",
                "operationID"
            ],
            "properties": {
                "checkUserIDList": {
                    "type": "array",
                    "maxItems": 100,
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.AccountCheckResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/user.AccountCheckResp_SingleUserStatus"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.AddBlacklistReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "toUserID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.AddBlacklistResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.AddFriendReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "toUserID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "reqMsg": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.AddFriendResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.AddFriendResponseReq": {
            "type": "object",
            "required": [
                "flag",
                "fromUserID",
                "operationID",
                "toUserID"
            ],
            "properties": {
                "flag": {
                    "type": "integer",
                    "enum": [
                        -1,
                        0,
                        1
                    ]
                },
                "fromUserID": {
                    "type": "string"
                },
                "handleMsg": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.AddFriendResponseResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.ApplicationGroupResponseReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "groupID",
                "handleResult",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "description": "application from FromUserID",
                    "type": "string"
                },
                "groupID": {
                    "type": "string"
                },
                "handleResult": {
                    "type": "integer",
                    "enum": [
                        -1,
                        1
                    ]
                },
                "handledMsg": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.ApplicationGroupResponseResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CancelMuteGroupMemberReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID",
                "userID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.CancelMuteGroupMemberResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CancelMuteGroupReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.CancelMuteGroupResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CleanUpMsgReq": {
            "type": "object",
            "required": [
                "operationID",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.CleanUpMsgResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.Comment": {
            "type": "object",
            "properties": {
                "content": {
                    "type": "string"
                },
                "contentID": {
                    "type": "string"
                },
                "createTime": {
                    "type": "integer"
                },
                "replyUserID": {
                    "type": "string"
                },
                "replyUserName": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                }
            }
        },
        "base_info.CommentOneWorkMomentReq": {
            "type": "object",
            "required": [
                "content",
                "operationID",
                "workMomentID"
            ],
            "properties": {
                "content": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "replyUserID": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "base_info.CommentOneWorkMomentResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.Conversation": {
            "type": "object",
            "required": [
                "conversationID",
                "conversationType",
                "ownerUserID"
            ],
            "properties": {
                "attachedInfo": {
                    "type": "string"
                },
                "conversationID": {
                    "type": "string"
                },
                "conversationType": {
                    "type": "integer"
                },
                "draftTextTime": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "groupAtType": {
                    "type": "integer"
                },
                "groupID": {
                    "type": "string"
                },
                "isNotInGroup": {
                    "type": "boolean"
                },
                "isPinned": {
                    "type": "boolean"
                },
                "isPrivateChat": {
                    "type": "boolean"
                },
                "ownerUserID": {
                    "type": "string"
                },
                "recvMsgOpt": {
                    "type": "integer",
                    "enum": [
                        0,
                        1,
                        2
                    ]
                },
                "unreadCount": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateDepartmentMemberReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "leader": {
                    "type": "integer"
                },
                "operationID": {
                    "type": "string"
                },
                "order": {
                    "type": "integer"
                },
                "position": {
                    "type": "string"
                },
                "status": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateDepartmentMemberResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateDepartmentReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "createTime": {
                    "type": "integer"
                },
                "departmentID": {
                    "type": "string"
                },
                "departmentType": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "memberNum": {
                    "type": "integer"
                },
                "name": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "order": {
                    "type": "integer"
                },
                "parentID": {
                    "type": "string"
                },
                "subDepartmentNum": {
                    "type": "integer"
                }
            }
        },
        "base_info.CreateDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateGroupReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "groupID": {
                    "type": "string"
                },
                "groupName": {
                    "type": "string"
                },
                "groupType": {
                    "type": "integer"
                },
                "introduction": {
                    "type": "string"
                },
                "memberList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.GroupAddMemberInfo"
                    }
                },
                "notification": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "ownerUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateGroupResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateOneWorkMomentReq": {
            "type": "object",
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "workMoment": {
                    "$ref": "#/definitions/office.WorkMoment"
                }
            }
        },
        "base_info.CreateOneWorkMomentResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateOrganizationUserReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "birth": {
                    "type": "integer"
                },
                "createTime": {
                    "type": "integer"
                },
                "email": {
                    "type": "string"
                },
                "englishName": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "gender": {
                    "type": "integer"
                },
                "mobile": {
                    "type": "string"
                },
                "nickname": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "telephone": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateOrganizationUserResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.CreateTagReq": {
            "type": "object",
            "required": [
                "operationID",
                "tagName",
                "userIDList"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "tagName": {
                    "description": "tag名称",
                    "type": "string"
                },
                "userIDList": {
                    "description": "用户ID列表",
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "base_info.CreateTagResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DelMsgReq": {
            "type": "object",
            "required": [
                "operationID",
                "seqList",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "seqList": {
                    "type": "array",
                    "items": {
                        "type": "integer"
                    }
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.DelMsgResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteCommentReq": {
            "type": "object",
            "required": [
                "contentID",
                "operationID",
                "workMomentID"
            ],
            "properties": {
                "contentID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteCommentResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteDepartmentReq": {
            "type": "object",
            "required": [
                "departmentID",
                "operationID"
            ],
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteFriendReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "toUserID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteFriendResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteOneWorkMomentReq": {
            "type": "object",
            "required": [
                "operationID",
                "workMomentID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteOneWorkMomentResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteOrganizationUserReq": {
            "type": "object",
            "required": [
                "operationID",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteOrganizationUserResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteTagReq": {
            "type": "object",
            "required": [
                "operationID",
                "tagID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "tagID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteTagResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteUserInDepartmentReq": {
            "type": "object",
            "required": [
                "departmentID",
                "operationID",
                "userID"
            ],
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.DeleteUserInDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.DismissGroupReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.DismissGroupResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.ExpireTime": {
            "type": "object",
            "properties": {
                "expireTimeSeconds": {
                    "type": "integer"
                }
            }
        },
        "base_info.ForceLogoutReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "platform"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string",
                    "maxLength": 64,
                    "minLength": 1
                },
                "operationID": {
                    "type": "string"
                },
                "platform": {
                    "type": "integer",
                    "maximum": 8,
                    "minimum": 1
                }
            }
        },
        "base_info.ForceLogoutResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetAllConversationsReq": {
            "type": "object",
            "required": [
                "operationID",
                "ownerUserID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "ownerUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetAllConversationsResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.Conversation"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetAllUsersUidReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetAllUsersUidResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetBlackListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetBlackListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetConversationReq": {
            "type": "object",
            "required": [
                "conversationID",
                "operationID",
                "ownerUserID"
            ],
            "properties": {
                "conversationID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "ownerUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetConversationResp": {
            "type": "object",
            "properties": {
                "data": {
                    "$ref": "#/definitions/base_info.Conversation"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetConversationsReq": {
            "type": "object",
            "required": [
                "conversationIDs",
                "operationID",
                "ownerUserID"
            ],
            "properties": {
                "conversationIDs": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                },
                "ownerUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetConversationsResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.Conversation"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetDepartmentMemberReq": {
            "type": "object",
            "required": [
                "departmentID",
                "operationID"
            ],
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetDepartmentMemberResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetFriendApplyListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetFriendApplyListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetFriendListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetFriendListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupAllMemberReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupAllMemberResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupApplicationListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "description": "作为管理员或群主收到的 进群申请",
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupApplicationListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupInfoReq": {
            "type": "object",
            "required": [
                "groupIDList",
                "operationID"
            ],
            "properties": {
                "groupIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupMembersInfoReq": {
            "type": "object",
            "required": [
                "groupID",
                "memberList",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "memberList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetGroupMembersInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetJoinedGroupListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetJoinedGroupListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetSelfApplyListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetSelfApplyListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetSelfUserInfoReq": {
            "type": "object",
            "required": [
                "operationID",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetSelfUserInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetSubDepartmentReq": {
            "type": "object",
            "required": [
                "departmentID",
                "operationID"
            ],
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetSubDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetTagSendLogsReq": {
            "type": "object",
            "required": [
                "operationID",
                "pageNumber",
                "showNumber"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "pageNumber": {
                    "type": "integer"
                },
                "showNumber": {
                    "type": "integer"
                }
            }
        },
        "base_info.GetTagSendLogsResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "currentPage": {
                            "type": "integer"
                        },
                        "logs": {
                            "type": "array",
                            "items": {
                                "$ref": "#/definitions/office.TagSendLog"
                            }
                        },
                        "showNumber": {
                            "type": "integer"
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserFriendWorkMomentsReq": {
            "type": "object",
            "required": [
                "operationID",
                "pageNumber",
                "showNumber"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "pageNumber": {
                    "type": "integer"
                },
                "showNumber": {
                    "type": "integer"
                }
            }
        },
        "base_info.GetUserFriendWorkMomentsResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "currentPage": {
                            "type": "integer"
                        },
                        "showNumber": {
                            "type": "integer"
                        },
                        "workMoments": {
                            "type": "array",
                            "items": {
                                "$ref": "#/definitions/base_info.WorkMoment"
                            }
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserInDepartmentReq": {
            "type": "object",
            "required": [
                "operationID",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserInDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserReqGroupApplicationListReq": {
            "type": "object",
            "required": [
                "operationID",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserTagByIDReq": {
            "type": "object",
            "required": [
                "operationID",
                "tagID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "tagID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserTagByIDResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "tag": {
                            "$ref": "#/definitions/office.Tag"
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserTagsReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserTagsResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "tags": {
                            "type": "array",
                            "items": {
                                "$ref": "#/definitions/office.Tag"
                            }
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserWorkMomentsReq": {
            "type": "object",
            "required": [
                "operationID",
                "pageNumber",
                "showNumber"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "pageNumber": {
                    "type": "integer"
                },
                "showNumber": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUserWorkMomentsResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "currentPage": {
                            "type": "integer"
                        },
                        "showNumber": {
                            "type": "integer"
                        },
                        "workMoments": {
                            "type": "array",
                            "items": {
                                "$ref": "#/definitions/base_info.WorkMoment"
                            }
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUsersInfoReq": {
            "type": "object",
            "required": [
                "operationID",
                "userIDList"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "base_info.GetUsersInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetUsersOnlineStatusReq": {
            "type": "object",
            "required": [
                "operationID",
                "userIDList"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "userIDList": {
                    "type": "array",
                    "maxItems": 200,
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "base_info.GetUsersOnlineStatusResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/pbRelay.GetUsersOnlineStatusResp_SuccessResult"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GetWorkMomentByIDReq": {
            "type": "object",
            "required": [
                "operationID",
                "workMomentID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "base_info.GetWorkMomentByIDResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "workMoment": {
                            "$ref": "#/definitions/base_info.WorkMoment"
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.GroupAddMemberInfo": {
            "type": "object",
            "required": [
                "roleLevel",
                "userID"
            ],
            "properties": {
                "roleLevel": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.ImportFriendReq": {
            "type": "object",
            "required": [
                "friendUserIDList",
                "fromUserID",
                "operationID"
            ],
            "properties": {
                "friendUserIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.ImportFriendResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.UserIDResult"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.InviteUserToGroupReq": {
            "type": "object",
            "required": [
                "groupID",
                "invitedUserIDList",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "invitedUserIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                },
                "reason": {
                    "type": "string"
                }
            }
        },
        "base_info.InviteUserToGroupResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.UserIDResult"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.IsFriendReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "toUserID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.IsFriendResp": {
            "type": "object",
            "properties": {
                "data": {
                    "$ref": "#/definitions/base_info.Response"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.JoinGroupReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "reqMessage": {
                    "type": "string"
                }
            }
        },
        "base_info.JoinGroupResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.KickGroupMemberReq": {
            "type": "object",
            "required": [
                "groupID",
                "kickedUserIDList",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "kickedUserIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                },
                "reason": {
                    "type": "string"
                }
            }
        },
        "base_info.KickGroupMemberResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.UserIDResult"
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.LikeOneWorkMomentReq": {
            "type": "object",
            "required": [
                "operationID",
                "workMomentID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "base_info.LikeOneWorkMomentResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.ManagementBatchSendMsgReq": {
            "type": "object",
            "required": [
                "contentType",
                "operationID",
                "sendID",
                "sessionType"
            ],
            "properties": {
                "contentType": {
                    "type": "integer"
                },
                "groupID": {
                    "type": "string"
                },
                "isOnlineOnly": {
                    "type": "boolean"
                },
                "offlinePushInfo": {
                    "$ref": "#/definitions/server_api_params.OfflinePushInfo"
                },
                "operationID": {
                    "type": "string"
                },
                "recvIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "sendID": {
                    "type": "string"
                },
                "senderFaceURL": {
                    "type": "string"
                },
                "senderNickname": {
                    "type": "string"
                },
                "senderPlatformID": {
                    "type": "integer"
                },
                "sessionType": {
                    "type": "integer"
                }
            }
        },
        "base_info.ManagementSendMsgReq": {
            "type": "object",
            "required": [
                "contentType",
                "operationID",
                "sendID",
                "sessionType"
            ],
            "properties": {
                "contentType": {
                    "type": "integer"
                },
                "groupID": {
                    "type": "string"
                },
                "isOnlineOnly": {
                    "type": "boolean"
                },
                "offlinePushInfo": {
                    "$ref": "#/definitions/server_api_params.OfflinePushInfo"
                },
                "operationID": {
                    "type": "string"
                },
                "recvID": {
                    "type": "string"
                },
                "sendID": {
                    "type": "string"
                },
                "senderFaceURL": {
                    "type": "string"
                },
                "senderNickname": {
                    "type": "string"
                },
                "senderPlatformID": {
                    "type": "integer"
                },
                "sessionType": {
                    "type": "integer"
                }
            }
        },
        "base_info.ManagementSendMsgResp": {
            "type": "object",
            "properties": {
                "data": {
                    "$ref": "#/definitions/server_api_params.UserSendMsgResp"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.MinioUploadFileResp": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "object",
                    "properties": {
                        "URL": {
                            "type": "string"
                        },
                        "newName": {
                            "type": "string"
                        },
                        "snapshotName": {
                            "type": "string"
                        },
                        "snapshotURL": {
                            "type": "string"
                        }
                    }
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.MuteGroupMemberReq": {
            "type": "object",
            "required": [
                "groupID",
                "mutedSeconds",
                "operationID",
                "userID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "mutedSeconds": {
                    "type": "integer"
                },
                "operationID": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.MuteGroupReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.MuteGroupResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.ParseTokenReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.ParseTokenResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.QuitGroupReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.QuitGroupResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.RemoveBlackListReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "toUserID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.RemoveBlackListResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.Response": {
            "type": "object",
            "properties": {
                "isFriend": {
                    "type": "boolean"
                }
            }
        },
        "base_info.SendMsg2TagReq": {
            "type": "object",
            "required": [
                "content",
                "operationID",
                "senderPlatformID"
            ],
            "properties": {
                "content": {
                    "type": "string"
                },
                "groupList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "operationID": {
                    "type": "string"
                },
                "senderPlatformID": {
                    "type": "integer"
                },
                "tagList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "userList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "base_info.SendMsg2TagResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.SetFriendRemarkReq": {
            "type": "object",
            "required": [
                "fromUserID",
                "operationID",
                "remark",
                "toUserID"
            ],
            "properties": {
                "fromUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "remark": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "base_info.SetFriendRemarkResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.SetGlobalRecvMessageOptReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "globalRecvMsgOpt": {
                    "type": "integer",
                    "enum": [
                        0,
                        1,
                        2
                    ]
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.SetGlobalRecvMessageOptResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.SetGroupInfoReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID"
            ],
            "properties": {
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "groupID": {
                    "type": "string"
                },
                "groupName": {
                    "type": "string"
                },
                "introduction": {
                    "type": "string"
                },
                "needVerification": {
                    "type": "integer"
                },
                "notification": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.SetGroupInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.SetGroupMemberInfoReq": {
            "type": "object",
            "required": [
                "groupID",
                "operationID",
                "userID"
            ],
            "properties": {
                "ex": {
                    "type": "string"
                },
                "groupID": {
                    "type": "string"
                },
                "nickname": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "roleLevel": {
                    "type": "integer",
                    "maximum": 3,
                    "minimum": 1
                },
                "userGroupFaceUrl": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.SetGroupMemberInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.SetTagReq": {
            "type": "object",
            "required": [
                "operationID",
                "tagID"
            ],
            "properties": {
                "increaseUserIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "newName": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "reduceUserIDList": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "tagID": {
                    "type": "string"
                }
            }
        },
        "base_info.SetTagResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.Swagger400Resp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer",
                    "example": 400
                },
                "errMsg": {
                    "type": "string",
                    "example": "err msg"
                }
            }
        },
        "base_info.Swagger500Resp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer",
                    "example": 500
                },
                "errMsg": {
                    "type": "string",
                    "example": "err msg"
                }
            }
        },
        "base_info.TransferGroupOwnerReq": {
            "type": "object",
            "required": [
                "groupID",
                "newOwnerUserID",
                "oldOwnerUserID",
                "operationID"
            ],
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "newOwnerUserID": {
                    "type": "string"
                },
                "oldOwnerUserID": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                }
            }
        },
        "base_info.TransferGroupOwnerResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.UpdateDepartmentReq": {
            "type": "object",
            "required": [
                "departmentID",
                "operationID"
            ],
            "properties": {
                "createTime": {
                    "type": "integer"
                },
                "departmentID": {
                    "type": "string"
                },
                "departmentType": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "memberNum": {
                    "type": "integer"
                },
                "name": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "order": {
                    "type": "integer"
                },
                "parentID": {
                    "type": "string"
                },
                "subDepartmentNum": {
                    "type": "integer"
                }
            }
        },
        "base_info.UpdateDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.UpdateOrganizationUserReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "birth": {
                    "type": "integer"
                },
                "createTime": {
                    "type": "integer"
                },
                "email": {
                    "type": "string"
                },
                "englishName": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "gender": {
                    "type": "integer"
                },
                "mobile": {
                    "type": "string"
                },
                "nickname": {
                    "type": "string"
                },
                "operationID": {
                    "type": "string"
                },
                "telephone": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.UpdateOrganizationUserResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.UpdateSelfUserInfoReq": {
            "type": "object",
            "required": [
                "operationID",
                "userID"
            ],
            "properties": {
                "birth": {
                    "type": "integer"
                },
                "email": {
                    "type": "string",
                    "maxLength": 64
                },
                "ex": {
                    "type": "string",
                    "maxLength": 1024
                },
                "faceURL": {
                    "type": "string",
                    "maxLength": 1024
                },
                "gender": {
                    "type": "integer",
                    "enum": [
                        0,
                        1,
                        2
                    ]
                },
                "nickname": {
                    "type": "string",
                    "maxLength": 64,
                    "minLength": 1
                },
                "operationID": {
                    "type": "string"
                },
                "phoneNumber": {
                    "type": "string",
                    "maxLength": 32
                },
                "userID": {
                    "type": "string",
                    "maxLength": 64,
                    "minLength": 1
                }
            }
        },
        "base_info.UpdateUserInDepartmentReq": {
            "type": "object",
            "required": [
                "operationID"
            ],
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "leader": {
                    "type": "integer"
                },
                "operationID": {
                    "type": "string"
                },
                "order": {
                    "type": "integer"
                },
                "position": {
                    "type": "string"
                },
                "status": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.UpdateUserInDepartmentResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.UpdateUserInfoResp": {
            "type": "object",
            "properties": {
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.UserIDResult": {
            "type": "object",
            "properties": {
                "result": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.UserRegisterReq": {
            "type": "object",
            "required": [
                "operationID",
                "platform",
                "secret",
                "userID"
            ],
            "properties": {
                "birth": {
                    "type": "integer"
                },
                "email": {
                    "type": "string",
                    "maxLength": 64
                },
                "ex": {
                    "type": "string",
                    "maxLength": 1024
                },
                "faceURL": {
                    "type": "string",
                    "maxLength": 1024
                },
                "gender": {
                    "type": "integer",
                    "enum": [
                        0,
                        1,
                        2
                    ]
                },
                "nickname": {
                    "type": "string",
                    "maxLength": 64,
                    "minLength": 1
                },
                "operationID": {
                    "type": "string"
                },
                "phoneNumber": {
                    "type": "string",
                    "maxLength": 32
                },
                "platform": {
                    "type": "integer",
                    "maximum": 7,
                    "minimum": 1
                },
                "secret": {
                    "type": "string",
                    "maxLength": 32
                },
                "userID": {
                    "type": "string",
                    "maxLength": 64,
                    "minLength": 1
                }
            }
        },
        "base_info.UserRegisterResp": {
            "type": "object",
            "properties": {
                "data": {
                    "$ref": "#/definitions/base_info.UserTokenInfo"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.UserTokenInfo": {
            "type": "object",
            "properties": {
                "expiredTime": {
                    "type": "integer"
                },
                "token": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "base_info.UserTokenReq": {
            "type": "object",
            "required": [
                "operationID",
                "platform",
                "secret",
                "userID"
            ],
            "properties": {
                "operationID": {
                    "type": "string"
                },
                "platform": {
                    "type": "integer",
                    "maximum": 8,
                    "minimum": 1
                },
                "secret": {
                    "type": "string",
                    "maxLength": 32
                },
                "userID": {
                    "type": "string",
                    "maxLength": 64,
                    "minLength": 1
                }
            }
        },
        "base_info.UserTokenResp": {
            "type": "object",
            "properties": {
                "data": {
                    "$ref": "#/definitions/base_info.UserTokenInfo"
                },
                "errCode": {
                    "type": "integer"
                },
                "errMsg": {
                    "type": "string"
                }
            }
        },
        "base_info.WorkMoment": {
            "type": "object",
            "properties": {
                "atUsers": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.WorkMomentUser"
                    }
                },
                "comments": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.Comment"
                    }
                },
                "content": {
                    "type": "string"
                },
                "createTime": {
                    "type": "integer"
                },
                "faceURL": {
                    "type": "string"
                },
                "likeUsers": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.WorkMomentUser"
                    }
                },
                "permission": {
                    "type": "integer"
                },
                "permissionUsers": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/base_info.WorkMomentUser"
                    }
                },
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "base_info.WorkMomentUser": {
            "type": "object",
            "properties": {
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                }
            }
        },
        "internal_api_manage.FileElem": {
            "type": "object",
            "properties": {
                "fileName": {
                    "type": "string"
                },
                "filePath": {
                    "type": "string"
                },
                "fileSize": {
                    "type": "integer"
                },
                "sourceURL": {
                    "type": "string"
                },
                "uuid": {
                    "type": "string"
                }
            }
        },
        "internal_api_manage.OANotificationElem": {
            "type": "object",
            "required": [
                "notificationFaceURL",
                "notificationName",
                "notificationType",
                "text"
            ],
            "properties": {
                "ex": {
                    "type": "string"
                },
                "fileElem": {
                    "$ref": "#/definitions/internal_api_manage.FileElem"
                },
                "mixType": {
                    "type": "integer"
                },
                "notificationFaceURL": {
                    "type": "string"
                },
                "notificationName": {
                    "type": "string"
                },
                "notificationType": {
                    "type": "integer"
                },
                "pictureElem": {
                    "$ref": "#/definitions/internal_api_manage.PictureElem"
                },
                "soundElem": {
                    "$ref": "#/definitions/internal_api_manage.SoundElem"
                },
                "text": {
                    "type": "string"
                },
                "url": {
                    "type": "string"
                },
                "videoElem": {
                    "$ref": "#/definitions/internal_api_manage.VideoElem"
                }
            }
        },
        "internal_api_manage.PictureBaseInfo": {
            "type": "object",
            "properties": {
                "height": {
                    "type": "integer"
                },
                "size": {
                    "type": "integer"
                },
                "type": {
                    "type": "string"
                },
                "url": {
                    "type": "string"
                },
                "uuid": {
                    "type": "string"
                },
                "width": {
                    "type": "integer"
                }
            }
        },
        "internal_api_manage.PictureElem": {
            "type": "object",
            "properties": {
                "bigPicture": {
                    "$ref": "#/definitions/internal_api_manage.PictureBaseInfo"
                },
                "snapshotPicture": {
                    "$ref": "#/definitions/internal_api_manage.PictureBaseInfo"
                },
                "sourcePath": {
                    "type": "string"
                },
                "sourcePicture": {
                    "$ref": "#/definitions/internal_api_manage.PictureBaseInfo"
                }
            }
        },
        "internal_api_manage.RevokeElem": {
            "type": "object",
            "required": [
                "revokeMsgClientID"
            ],
            "properties": {
                "revokeMsgClientID": {
                    "type": "string"
                }
            }
        },
        "internal_api_manage.SoundElem": {
            "type": "object",
            "properties": {
                "dataSize": {
                    "type": "integer"
                },
                "duration": {
                    "type": "integer"
                },
                "soundPath": {
                    "type": "string"
                },
                "sourceURL": {
                    "type": "string"
                },
                "uuid": {
                    "type": "string"
                }
            }
        },
        "internal_api_manage.TextElem": {
            "type": "object",
            "required": [
                "text"
            ],
            "properties": {
                "text": {
                    "type": "string"
                }
            }
        },
        "internal_api_manage.VideoElem": {
            "type": "object",
            "properties": {
                "duration": {
                    "type": "integer"
                },
                "snapshotHeight": {
                    "type": "integer"
                },
                "snapshotPath": {
                    "type": "string"
                },
                "snapshotSize": {
                    "type": "integer"
                },
                "snapshotURL": {
                    "type": "string"
                },
                "snapshotUUID": {
                    "type": "string"
                },
                "snapshotWidth": {
                    "type": "integer"
                },
                "videoPath": {
                    "type": "string"
                },
                "videoSize": {
                    "type": "integer"
                },
                "videoType": {
                    "type": "string"
                },
                "videoURL": {
                    "type": "string"
                },
                "videoUUID": {
                    "type": "string"
                }
            }
        },
        "office.Comment": {
            "type": "object",
            "properties": {
                "content": {
                    "type": "string"
                },
                "contentID": {
                    "type": "string"
                },
                "createTime": {
                    "type": "integer"
                },
                "faceURL": {
                    "type": "string"
                },
                "replyUserID": {
                    "type": "string"
                },
                "replyUserName": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                }
            }
        },
        "office.PermissionGroup": {
            "type": "object",
            "properties": {
                "groupID": {
                    "type": "string"
                },
                "groupName": {
                    "type": "string"
                }
            }
        },
        "office.Tag": {
            "type": "object",
            "properties": {
                "tagID": {
                    "type": "string"
                },
                "tagName": {
                    "type": "string"
                },
                "userList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.TagUser"
                    }
                }
            }
        },
        "office.TagSendLog": {
            "type": "object",
            "properties": {
                "content": {
                    "type": "string"
                },
                "sendTime": {
                    "type": "integer"
                },
                "userList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.TagUser"
                    }
                }
            }
        },
        "office.TagUser": {
            "type": "object",
            "properties": {
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                }
            }
        },
        "office.WorkMoment": {
            "type": "object",
            "properties": {
                "atUserList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.WorkMomentUser"
                    }
                },
                "comments": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.Comment"
                    }
                },
                "content": {
                    "type": "string"
                },
                "createTime": {
                    "type": "integer"
                },
                "faceURL": {
                    "type": "string"
                },
                "likeUserList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.WorkMomentUser"
                    }
                },
                "permission": {
                    "type": "integer"
                },
                "permissionGroupList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.PermissionGroup"
                    }
                },
                "permissionUserList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/office.WorkMomentUser"
                    }
                },
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                },
                "workMomentID": {
                    "type": "string"
                }
            }
        },
        "office.WorkMomentUser": {
            "type": "object",
            "properties": {
                "userID": {
                    "type": "string"
                },
                "userName": {
                    "type": "string"
                }
            }
        },
        "pbRelay.GetUsersOnlineStatusResp_SuccessDetail": {
            "type": "object",
            "properties": {
                "platform": {
                    "type": "string"
                },
                "status": {
                    "type": "string"
                }
            }
        },
        "pbRelay.GetUsersOnlineStatusResp_SuccessResult": {
            "type": "object",
            "properties": {
                "detailPlatformStatus": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/pbRelay.GetUsersOnlineStatusResp_SuccessDetail"
                    }
                },
                "status": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.Department": {
            "type": "object",
            "properties": {
                "createTime": {
                    "type": "integer"
                },
                "departmentID": {
                    "type": "string"
                },
                "departmentType": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "memberNum": {
                    "type": "integer"
                },
                "name": {
                    "type": "string"
                },
                "order": {
                    "type": "integer"
                },
                "parentID": {
                    "type": "string"
                },
                "subDepartmentNum": {
                    "type": "integer"
                }
            }
        },
        "server_api_params.DepartmentMember": {
            "type": "object",
            "properties": {
                "departmentID": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "leader": {
                    "type": "integer"
                },
                "order": {
                    "type": "integer"
                },
                "position": {
                    "type": "string"
                },
                "status": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.FriendInfo": {
            "type": "object",
            "properties": {
                "addSource": {
                    "type": "integer"
                },
                "createTime": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "friendUser": {
                    "$ref": "#/definitions/server_api_params.UserInfo"
                },
                "operatorUserID": {
                    "type": "string"
                },
                "ownerUserID": {
                    "type": "string"
                },
                "remark": {
                    "type": "string"
                }
            }
        },
        "server_api_params.FriendRequest": {
            "type": "object",
            "properties": {
                "createTime": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "fromFaceURL": {
                    "type": "string"
                },
                "fromGender": {
                    "type": "integer"
                },
                "fromNickname": {
                    "type": "string"
                },
                "fromUserID": {
                    "type": "string"
                },
                "handleMsg": {
                    "type": "string"
                },
                "handleResult": {
                    "type": "integer"
                },
                "handleTime": {
                    "type": "integer"
                },
                "handlerUserID": {
                    "type": "string"
                },
                "reqMsg": {
                    "type": "string"
                },
                "toFaceURL": {
                    "type": "string"
                },
                "toGender": {
                    "type": "integer"
                },
                "toNickname": {
                    "type": "string"
                },
                "toUserID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.GroupInfo": {
            "type": "object",
            "properties": {
                "createTime": {
                    "type": "integer"
                },
                "creatorUserID": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "groupID": {
                    "type": "string"
                },
                "groupName": {
                    "type": "string"
                },
                "groupType": {
                    "type": "integer"
                },
                "introduction": {
                    "type": "string"
                },
                "memberCount": {
                    "type": "integer"
                },
                "needVerification": {
                    "type": "integer"
                },
                "notification": {
                    "type": "string"
                },
                "ownerUserID": {
                    "type": "string"
                },
                "status": {
                    "type": "integer"
                }
            }
        },
        "server_api_params.GroupMemberFullInfo": {
            "type": "object",
            "properties": {
                "appMangerLevel": {
                    "type": "integer"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "groupID": {
                    "type": "string"
                },
                "joinSource": {
                    "type": "integer"
                },
                "joinTime": {
                    "type": "integer"
                },
                "muteEndTime": {
                    "type": "integer"
                },
                "nickname": {
                    "type": "string"
                },
                "operatorUserID": {
                    "type": "string"
                },
                "roleLevel": {
                    "type": "integer"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.GroupRequest": {
            "type": "object",
            "properties": {
                "ex": {
                    "type": "string"
                },
                "groupInfo": {
                    "$ref": "#/definitions/server_api_params.GroupInfo"
                },
                "handleMsg": {
                    "type": "string"
                },
                "handleResult": {
                    "type": "integer"
                },
                "handleTime": {
                    "type": "integer"
                },
                "handleUserID": {
                    "type": "string"
                },
                "reqMsg": {
                    "type": "string"
                },
                "reqTime": {
                    "type": "integer"
                },
                "userInfo": {
                    "$ref": "#/definitions/server_api_params.PublicUserInfo"
                }
            }
        },
        "server_api_params.OfflinePushInfo": {
            "type": "object",
            "properties": {
                "desc": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "iOSBadgeCount": {
                    "type": "boolean"
                },
                "iOSPushSound": {
                    "type": "string"
                },
                "title": {
                    "type": "string"
                }
            }
        },
        "server_api_params.OrganizationUser": {
            "type": "object",
            "properties": {
                "birth": {
                    "type": "integer"
                },
                "createTime": {
                    "type": "integer"
                },
                "email": {
                    "type": "string"
                },
                "englishName": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "gender": {
                    "type": "integer"
                },
                "mobile": {
                    "type": "string"
                },
                "nickname": {
                    "type": "string"
                },
                "telephone": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.PublicUserInfo": {
            "type": "object",
            "properties": {
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "gender": {
                    "type": "integer"
                },
                "nickname": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.UserDepartmentMember": {
            "type": "object",
            "properties": {
                "departmentMember": {
                    "$ref": "#/definitions/server_api_params.DepartmentMember"
                },
                "organizationUser": {
                    "$ref": "#/definitions/server_api_params.OrganizationUser"
                }
            }
        },
        "server_api_params.UserInDepartment": {
            "type": "object",
            "properties": {
                "departmentMemberList": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/server_api_params.DepartmentMember"
                    }
                },
                "organizationUser": {
                    "$ref": "#/definitions/server_api_params.OrganizationUser"
                }
            }
        },
        "server_api_params.UserInfo": {
            "type": "object",
            "properties": {
                "appMangerLevel": {
                    "type": "integer"
                },
                "birth": {
                    "type": "integer"
                },
                "createTime": {
                    "type": "integer"
                },
                "email": {
                    "type": "string"
                },
                "ex": {
                    "type": "string"
                },
                "faceURL": {
                    "type": "string"
                },
                "gender": {
                    "type": "integer"
                },
                "globalRecvMsgOpt": {
                    "type": "integer"
                },
                "nickname": {
                    "type": "string"
                },
                "phoneNumber": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        },
        "server_api_params.UserSendMsgResp": {
            "type": "object",
            "properties": {
                "clientMsgID": {
                    "type": "string"
                },
                "sendTime": {
                    "type": "integer"
                },
                "serverMsgID": {
                    "type": "string"
                }
            }
        },
        "user.AccountCheckResp_SingleUserStatus": {
            "type": "object",
            "properties": {
                "accountStatus": {
                    "type": "string"
                },
                "userID": {
                    "type": "string"
                }
            }
        }
    }
}`

// SwaggerInfo holds exported Swagger Info so clients can modify it
var SwaggerInfo = &swag.Spec{
	Version:          "1.0",
	Host:             "",
	BasePath:         "/",
	Schemes:          []string{},
	Title:            "open-IM-Server API",
	Description:      "open-IM-Server 的API服务器文档, 文档中所有请求都有一个operationID字段用于链路追踪",
	InfoInstanceName: "swagger",
	SwaggerTemplate:  docTemplate,
}

func init() {
	swag.Register(SwaggerInfo.InstanceName(), SwaggerInfo)
}
